diff --exclude='*swp*' -Naur imp/lib/Compose.php imp/lib/Compose.php
--- imp/lib/Compose.php	2009-12-21 22:07:37.000000000 +0100
+++ imp/lib/Compose.php	2009-12-22 00:08:11.000000000 +0100
@@ -2036,7 +2036,13 @@
             }
         }
         $part->setType($type);
-        $part->setCharset(NLS::getCharset());
+        $charset = NLS::getCharset();
+	if (strlen($type) > 4 && substr($type, -4) == 'html') {
+          require_once 'Horde/MIME/Magic.php';
+          $html_charset = MIME_Magic::getHtmlCharset($tempfile);
+          $charset = $html_charset != false ? $html_charset : $charset;
+        }
+        $part->setCharset($charset);
         $part->setName($filename);
         $part->setBytes($_FILES[$name]['size']);
         if ($disposition) {
diff --exclude='*swp*' -Naur lib/Horde/MIME/Magic.php lib/Horde/MIME/Magic.php
--- lib/Horde/MIME/Magic.php	2009-12-21 22:07:37.000000000 +0100
+++ lib/Horde/MIME/Magic.php	2009-12-21 23:58:21.000000000 +0100
@@ -269,4 +269,21 @@
         return false;
     }
 
+    /**
+     *
+     */
+    function getHtmlCharset($path)
+    {
+      /* note: For the moment, don't try to use PHP Mimetype. */
+
+      $data = @file_get_contents($path);
+      if (!is_null($data)) {
+        $pattern = '/<meta +http-equiv="Content-Type" +content="text\/html; +charset=([^"]+)" *>/i';
+        if (preg_match($pattern, $data, $matches)) {
+          return $matches[1];
+        }
+      }
+
+      return false;
+    }
 }
